(*************************** token ************************)

type token =
  Ident of string
(* | Dollar_ident of string *)
| Integer_constant of int
| Tok_constant of string
| Var_constant of string
| Toklist_constant of string list
| String_constant of string
| Comment of string
| Symbol of string
| Nulltoken
| Lines of (int * token)
| Endofstream;;


(****************** Hilfsfunktionen fuer Lexer ************)

let remove_backslashes_in_tok s =

  let l = String.length s in

  let rec remove_rec i =
  ( if i>=l then 
      []
    else let c = s.[i] in
      if c='\\' & i<l-1 then
      ( let cc=s.[i+1] in
        match c with
          '0' -> (String.make 10 ' ') :: remove_rec (i+2)
        | '1' -> (String.make 1 ' ') :: remove_rec (i+2)
        | '2' -> (String.make 2 ' ') :: remove_rec (i+2)
        | '3' -> (String.make 3 ' ') :: remove_rec (i+2)
        | '4' -> (String.make 4 ' ') :: remove_rec (i+2)
        | '5' -> (String.make 5 ' ') :: remove_rec (i+2)
        | '6' -> (String.make 6 ' ') :: remove_rec (i+2)
        | '7' -> (String.make 7 ' ') :: remove_rec (i+2)
        | '8' -> (String.make 8 ' ') :: remove_rec (i+2)
        | '9' -> (String.make 9 ' ') :: remove_rec (i+2)
        | 'S' -> " " :: remove_rec (i+2)
        | 'R' -> "\r" :: remove_rec (i+2)
        | 'L' -> "\n" :: remove_rec (i+2)
        | 'T' -> "\t" :: remove_rec (i+2)
        | _   -> (String.make 1 cc) :: remove_rec (i+2)
      )
      else (String.make 1 c) :: remove_rec (i+1)
  ) in

  String.concat "" (remove_rec 0)
;;


let remove_backslashes_in_string s =

  let l = String.length s in

  let rec remove_rec i =
  ( if i>=l then 
      []
    else let c = s.[i] in
      if c='\\' & i<l-1 then
      ( let cc=s.[i+1] in
        (String.make 1 cc) :: remove_rec (i+2)
      )
      else (String.make 1 c) :: remove_rec (i+1)
  ) in

  String.concat "" (remove_rec 0)
;;


(* spaltet ``...`` in Liste auf *)
let split_list s =

  let l = String.length s in

  let rec split_rec t i =
  ( if i>=l then
    ( if t = [] then [] else [ String.concat "" t ] )
    else
      let c = s.[i] in
      match c with
        ('\n' | ' ' | '\t' | '\r') -> 
           if t = [] then
             split_rec [] (i+1)
           else
             (String.concat "" t) :: (split_rec [] (i+1))
      | _ -> split_rec (t @ [String.make 1 c]) (i+1)
  ) in

  split_rec [] 0
;;


let count_lines s =
  let n = ref 0 in
  for i = 0 to String.length s - 1 do
    if s.[i] = '\n' then incr n
  done;
  !n
;;
